/*
 *  dataview.h
 *
 *  Copyright (C) 1999 Laszlo Boloni
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __DATAVIEW_H__
#define __DATAVIEW_H__

#include <qbutton.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h> 
#include <qspinbox.h>
#include <kcmodule.h>
#include <kcolorbtn.h>

class QButtonGroup;

class KDataviewConfig : public KCModule
{
  Q_OBJECT

public:
    KDataviewConfig( QWidget *parent=0, const char* name=0 );
    ~KDataviewConfig( );

    KConfigBase *config;

    virtual void load();
    virtual void save();
    virtual void applySettings();
    virtual void defaults();

protected slots:
    void slotChanged();
private:
    QVBoxLayout *layout;
    QLabel *tips_label;
    
    QSpinBox *maxItemsInView;
    QCheckBox *autosave;
    QSpinBox *autosaveInterval;
};

#endif

