/*
    This file is part of the KDE system
    Copyright (C)  1999 Boloni Laszlo

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.

    gofaiDataViewPointer.h

    This allows a limited view of the whole data structure

*/

#ifndef __GOFAI_DATA_VIEW_POINTER_H
#define __GOFAI_DATA_VIEW_POINTER_H

/**
    Used to indicate one element in a data view
 */
#include "gofaiItem.h"
#include "gofaiVisualDataStruct.h"

class gofaiDataView;

class gofaiDataViewPointer {
public:
    gofaiDataViewPointer(gofaiDataView *dv);
  enum Place {Main, Context};
  bool valid;
  Place place;
  int index;
  // functions
  void invalidate();
  void setTo(int index, Place place);
  gofaiVisualItem* getVisualItem();
  gofaiItem* getItem();
  bool equals(gofaiDataViewPointer &other);
private:
  gofaiDataView *dv;
};


#endif // __GOFAI_DATA_VIEW_POINTER_H
