/* 
    This file is part of the KDE system
    Copyright (C)  1999 Boloni Laszlo
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
 
    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
/*
 * gofaiVisualArrangement.h
 *
 *  Arranges the view in a nice visual interface.
 *
 */ 

#ifndef __GOFAI_VISUALARRANGEMENT_H
#define __GOFAI_VISUALARRANGEMENT_H


struct gofaiPosition {
    gofaiPosition();
    int centerx, centery;
    int rx, ry;
    float angle;
    bool occupied;
    void setFinalPositions();
    void Randomize(float rnd_percent);
    float totalLengthOfConnections(gofaiPosition *pos,
				   gofaiVisualItem *it2,
				   gofaiDataView *dv);
    gofaiVisualItem *it;
};

struct gofaiCircle {
    gofaiCircle();
    gofaiPosition pos[MAX_ITEMS_IN_VIEW];
    int elements;
    float angle_seed;
    void setUnoccupied();
    void computePositions(int centerx, int centery, int rx, int ry);
    void Randomize(float rnd_percent);
    void setFinalPositions();
    float totalLengthOfConnections(gofaiPosition *pos,
				   gofaiVisualItem *it,
				   gofaiDataView *dv);
};

struct gofaiConcentricArrangement {
    gofaiConcentricArrangement();
    gofaiCircle cir[MAX_LEVELS];
    int circles;
    void setUnoccupied();
    void computePositions(int centerx, int centery, int rx, int ry);
    void Randomize(float rand);
    void setFinalPositions();
    float totalLengthOfConnections(gofaiPosition *pos,
				   gofaiVisualItem *it,
				   gofaiDataView *dv);
    int arrange(gofaiDataView &dv,
		 int centerx, int centery, 
		 int rx, int ry);
};



#endif
